package bttool;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */
import java.awt.*;
import java.awt.event.*;
import java.util.*;

class mainMenu
extends MenuBar
implements ActionListener
{

  //Wichtige Menuepunkte
  private String KONST_SCHLACHT = "Schlacht";
  private String KONST_SCHLACHT_NEU = "Neue Schlacht";
  private String KONST_SCHLACHT_LADEN = "Schlacht Laden";
  private String KONST_SCHLACHT_SPEICHERN = "Schlacht Speichern";
  private String KONST_SCHLACHT_BEENDEN = "Schlacht Speichern + Beenden";
  private String KONST_PROGRAMM_BEENDEN = "Programm Beenden";
  private String KONST_MECH = "Mech";
  private String KONST_MECH_NEU = "Neue Mech";
  private String KONST_MECH_LADEN = "Mech Laden";
  private String KONST_TOOLS = "Tools";
  private String KONST_TOOLS_GC = "Garbage Collection";
  private String KONST_HILFE = "Hilfe";

  //eigene Menue
  private Menu menu;

  //das Frame
  private Frame frame;
  public Font font;

  //in dem Vector stehen die einzelnen Mechs
  public Vector schlacht;

  //FileLoader
  private FileLoader loader;
  private String location;

  //MainInstance
  public Controller controller;

  //SchlachtFile
  private String schlachtFile;

//################################################################################################
//Beginn der Methoden: Konstruktor
//################################################################################################

  public mainMenu(){}

  /**
   * Dieser Konstruktor erzeugt das Men und baut den Menlistener rein.
   */
  public mainMenu(Controller controller)
  {
    this.controller = controller;
    this.location="C:\\_eigen\\disk\\Spiele\\Battlemech\\02_12_06";

    ActionListener listener = this;

    this.schlacht = new Vector();

    this.schlachtFile="";

    //Datei
    this.menu = new Menu(this.KONST_SCHLACHT);
    this.menu.addActionListener(listener);
    this.menu.add(new MenuItem(this.KONST_SCHLACHT_NEU));
    this.menu.addSeparator();
    this.menu.add(new MenuItem(this.KONST_SCHLACHT_LADEN));
    this.menu.add(new MenuItem(this.KONST_SCHLACHT_SPEICHERN));
    this.menu.addSeparator();
    this.menu.add(new MenuItem(this.KONST_SCHLACHT_BEENDEN));
    this.menu.addSeparator();
    this.menu.add(new MenuItem(this.KONST_PROGRAMM_BEENDEN));
    add(this.menu);
    //Bearbeiten
    this.menu = new Menu(this.KONST_MECH);
    this.menu.addActionListener(listener);
    this.menu.add(new MenuItem(this.KONST_MECH_NEU));
    this.menu.addSeparator();
    this.menu.add(new MenuItem(this.KONST_MECH_LADEN));
    add(this.menu);
    //Optionen
    this.menu = new Menu(this.KONST_TOOLS);
    this.menu.addActionListener(listener);
    this.menu.add(new MenuItem(this.KONST_TOOLS_GC));
    add(this.menu);
    //Hilfe
    this.menu = new Menu(this.KONST_HILFE);
    this.menu.addActionListener(listener);
    add(this.menu);
  }

//################################################################################################
//Listener
//################################################################################################

  /**
   * Dieser Listener reagiert auf alle Menpunkte.
   */
  public void actionPerformed(ActionEvent event)
  {

    ////////////////////////////////////////////////////////////////////////
    //Programm beenden
    if(event.getActionCommand().equals(this.KONST_PROGRAMM_BEENDEN)){System.exit(0);}

    ////////////////////////////////////////////////////////////////////////
    //Start des GC
    if(event.getActionCommand().equals(this.KONST_TOOLS_GC))
    {
      System.gc();
    }

    ////////////////////////////////////////////////////////////////////////
    //Schlacht speichern
    if( event.getActionCommand().equals(this.KONST_SCHLACHT_SPEICHERN))
    {
      this.schlachtSpeichern(this.schlachtFile);
    }

    ////////////////////////////////////////////////////////////////////////
    //Schlacht laden
    if( event.getActionCommand().equals(this.KONST_SCHLACHT_LADEN))
    {
      //Vorherige lschen
      this.schlacht = new Vector();

      this.schlachtLadenMenue();
    }

    /**@todo: bei einer neuen Schlacht mu noch der FileName abgefragt werden*/

    ////////////////////////////////////////////////////////////////////////
    //Neue Schlacht || Schlacht Beenden
    if( event.getActionCommand().equals(this.KONST_SCHLACHT_NEU)    ||
        event.getActionCommand().equals(this.KONST_SCHLACHT_BEENDEN))
    {

     //Die vorhandene Schlacht wird gespeichert
      this.schlachtSpeichern(this.schlachtFile);

       //alle Mechs speichern und schlieen
      for(int i=0; i<this.schlacht.size(); i++)
      {
        this.mechSpeichernUndSchlieen((Mech) this.schlacht.get(i));
      }

      this.schlacht = new Vector();

      //Schlacht laden
      if( event.getActionCommand().equals(this.KONST_SCHLACHT_NEU)){this.schlachtLadenMenue();}

    }

    ////////////////////////////////////////////////////////////////////////
    //Mech laden
    if(event.getActionCommand().equals(this.KONST_MECH_LADEN))
    {
      //einen MechLaden und an die Schlacht anfgen
      this.mechLadenMenue();
    }

    ////////////////////////////////////////////////////////////////////////
    //MainFrame neu zeichnen
    this.controller.mainFrame.setVisible(false);
    this.controller.anzeigen();
  }

//################################################################################################
//Methoden, die sich aus dem Men ergeben
//################################################################################################

  /**
   * Diese Methode stellt den Dialog zur Verfgung, um eine Schlacht zu laden
   * und verweist auf die Methode, die die Schlacht auch tatschlich ldt.
   */
  public void schlachtLadenMenue()
  {
      this.loader = new FileLoader(this.location);
      this.loader.title = "Schlacht laden";
      this.schlachtFile = loader.load();

      this.schlachtLaden(this.schlachtFile);

      //Neue Location von wo aus beim nchsten Aufruf geladen wird
      this.location = this.loader.location;

  }

  /**
   * Diese Methode ldt tatschlich eine Schlacht.
   */
  public void schlachtLaden(String fileName)
  {
    System.out.println("Schlacht laden: <"+fileName+">");
      if(fileName.length()>4)
      {

        lade schlachtFileLaden = new lade();

        //Einlesen des Files in den Vector des Objectes schlachtFileLaden.
        schlachtFileLaden.einlesenFile(fileName);

        int mechZeiger=1;
        String sMechZeiger="00";

        String fileNameMech;

        //jetzt werden die Mechs dort herausgeholt
        fileNameMech = (String) schlachtFileLaden.inhalt.get("Mech001");

        while(null != fileNameMech)
        {
          System.out.println("Mechladen: <"+fileNameMech+">");
          this.mechLaden(fileNameMech);
          mechZeiger++;
          if(mechZeiger>9){sMechZeiger="0";}
          if(mechZeiger>99){sMechZeiger="";}
          fileNameMech = (String) schlachtFileLaden.inhalt.get("Mech"+sMechZeiger+mechZeiger);
        }
      }
  }
  /**
   * Diese Methode speichert eine einzelne Schlacht in das File fileName.
   */
  public void schlachtSpeichern(String fileName)
  {

    if(null != fileName && fileName.length()>4 && null != this.schlacht)
    {
       //alle Mechs speichern
      for(int i=0; i<this.schlacht.size(); i++)
      {
        ((Mech) this.schlacht.get(i)).speichern();
      }


      speicher speicher = new speicher();
      String nameGrund = "Mech";
      String fueller = "00";
      speicher.inhaltV = new Vector();

      for(int i=1; i<=this.schlacht.size(); i++)
      {
        if(i>9){fueller="0";}
        if(i>99){fueller="";}
        speicher.inhaltV.add(nameGrund+fueller+i+":"+((Mech) this.schlacht.get(i-1)).fileSpeichern);
      }
      speicher.speichernFileV(fileName);
    }
  }

  /**
   * Diese Methode speichert einzelne Mechs und schliet diese.
   */
   public void mechSpeichernUndSchlieen(Mech mech)
   {
    mech.speichern();
    mech.setVisible(false);
    mech.dispose();
   }

  /**
   * Diese Methode stellt das Men zur Verfgung, mit der Mechs geladen werden, auerdem
   * wird von hier aus die Methode aufgerufen, die auch tatschlich Mechs ldt.
   */
   public void mechLadenMenue()
   {
      this.loader = new FileLoader(this.location);
      this.loader.title = "Mech laden";
      String fileName = loader.load();
      this.mechLaden(fileName);
   }

   /**
    * Diese Methode ldt Mechs und fgt diese dem Vector hinzu.
    */
    public void mechLaden(String fileName)
    {
      if(fileName.length()>4)
      {
        this.location = this.loader.location;
        this.schlacht.add(new Mech(fileName));
        ((Mech) this.schlacht.lastElement()).laden();
        ((Mech) this.schlacht.lastElement()).anzeigen();
      }
    }
}